#include <stdio.h>

class TBase
{
public:
  virtual void print () = 0;
};

class TInteger: public TBase
{
private:
  int content;
public:
  virtual void print ();
  TInteger (int i);
};

class TString: public TBase
{
private:
  char *content;
public:
  virtual void print ();
  TString (char *s);
};

void TInteger::print ()
{
  printf ("Integer: %d\n", content);
}

void TString::print ()
{
  printf ("String: \"%s\"\n", content);
}

TInteger::TInteger (int i)
{
  content = i;
}

TString::TString (char *s)
{
  content = s;
}

int main (void)
{
  TBase *object[] = { new TInteger (42),
                      new TString ("Hello, world!"),
                      NULL };

  ((TInteger *) object[0])->content = 137;

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  for (int i = 0; object[i]; i++)
    delete object[i];

  return 0;
}
