#include <iostream>
#include <string>

using namespace std;

const bool something_really_complicated = true;

class TComplicated
{
  string *content;

public:
  TComplicated ()
  {
    content = NULL;
  }

  TComplicated (const char *content)
  {
    this->content = new string (content);
  }

  TComplicated (const TComplicated &src)
  {
    if (src.content)
      this->content = new string (*src.content);
    else
      this->content = NULL;
  }

  ~TComplicated ()
  {
    cout << "~TComplicated (): content = ";
    print ();
    if (content)
      delete content;
    content = NULL;
  }

  TComplicated &operator = (const TComplicated &src)
  {
    if (src.content)
      this->content = new string (*src.content);
    else
      this->content = NULL;
    return *this;
  }

  void move (TComplicated &src)
  {
    if (content)
      delete content;
    this->content = src.content;
    src.content = NULL;
  }

  void print ()
  {
    if (content)
      cout << *content << endl;
    else
      cout << "(NULL)" << endl;
  }
};

int main ()
{
  TComplicated d;
  if (something_really_complicated)
    {
      TComplicated c = "Hello, world!";
      c.print ();
      d.move (c);
    }
  d.print ();
  return 0;
}
