#include <stdio.h>

struct TBase
{
  virtual void print ()
  {
    printf ("(Base)\n");
  }
};

struct THello: public TBase
{
  const char *content;

  THello (const char *s)
  {
    content = s;
  }

  explicit THello (const TBase &b)
  {
    content = "(Base)";
  }

  virtual void print ()
  {
    printf ("%s\n", content);
  }
};

void print_it (const THello &h)
{
  printf ("%s\n", h.content);
}

int main ()
{
  TBase b;
  print_it (b);
  return 0;
}
