#include <stdio.h>

void ext_eucl (int a, int b, int *ss, int *tt, int *ggt)
{
  int r0 = a;
  int r1 = b;
  int s0 = 1;
  int s1 = 0;
  int t0 = 0;
  int t1 = 1;
  int r2 = r0 % r1;
  while (r2)
    {
      int q = r0 / r1;
      int s2 = s0 - q * s1;
      int t2 = t0 - q * t1;
      r0 = r1;
      s0 = s1;
      t0 = t1;
      r1 = r2;
      s1 = s2;
      t1 = t2;
      r2 = r0 % r1;
    }
  *ggt = r1;
  *ss = s1;
  *tt = t1;
}

int main (void)
{
  int p = 11117;
  int q = 11171;
  int n = (p - 1) * (q - 1);
  int d;
  int t;
  int ggt;
  printf ("        e          d        db\n");
  for (int e = 137; e < 256; e++)
    {
      int db = 2;
      while (db < n && (e * db) % n != 1)
        db++;
      ext_eucl (e, n, &d, &t, &ggt);
      printf ("%10d %10d %10d\n", e, d, db);
    }
  return 0;
}
