#include <stdio.h>

void ext_eucl (int a, int b, int *ss, int *tt, int *ggt)
{
  int r0 = a;
  int r1 = b;
  int s0 = 1;
  int s1 = 0;
  int t0 = 0;
  int t1 = 1;
  int r2 = r0 % r1;
  while (r2)
    {
      int q = r0 / r1;
      int s2 = s0 - q * s1;
      int t2 = t0 - q * t1;
      r0 = r1;
      s0 = s1;
      t0 = t1;
      r1 = r2;
      s1 = s2;
      t1 = t2;
      r2 = r0 % r1;
    }
  *ggt = r1;
  *ss = s1;
  *tt = t1;
}

int gen_key (int n, int e)
{
  int d;
  int t;
  int ggt;
  ext_eucl (e, n, &d, &t, &ggt);
  while (d < 0)
    d += n;
  if (ggt != 1)
    return -1;
  else
    return d;
}

int main (void)
{
  int p = 11117;
  int q = 11171;
  int N = p * q;
  int n = (p - 1) * (q - 1);
  int e = 137;
  printf ("Öffentlicher Schlüssel: N = %d, e = %d\n", N, e);
  int d = gen_key (n, e);
  printf ("Geheimer Schlüssel: n = %d, d = %d\n", n, d);
  return 0;
}
